#include once <alloc.asm>
#include once <stackf.asm>
#include once <error.asm>

VAL: ; Computes VAL(a$) using ROM FP-CALC
	 ; HL = address of a$
	 ; Returns FP number in C ED LH registers
	 ; A Register = 1 => Free a$ on return
	
	PROC

	LOCAL STK_STO_S
	LOCAL __RET_ZERO
	LOCAL ERR_SP
	LOCAL TMP
	LOCAL __VAL_ERROR
	LOCAL __VAL_EMPTY

ERR_SP		EQU 23613
STK_STO_S	EQU	2AB2h
TMP			EQU 23629 ;(DEST)

	push af
	ld a, h
	or l
	jr z, __RET_ZERO ; NULL STRING => Return 0 

	push hl	; Not null string. Save its address for later

	ld c, (hl)
	inc hl
	ld b, (hl)
	inc hl

	ld a, b
	or c
	jr z, __VAL_EMPTY ; Jumps VAL_EMPTY on empty string

	ex de, hl ; DE = String start

	ld hl, (ERR_SP)
	ld (TMP), hl

	ld hl, __VAL_ERROR
	push hl

	ld hl, 0
	add hl, sp
	ld (ERR_SP), hl

	xor a	  ; A = 0 => No free on return
	call STK_STO_S ; Enter in on the stack

	ld b, 1Dh ; "VAL"
	rst 28h	; ROM CALC
	defb 1Dh ; VAL
	defb 38h ; END CALC

	pop bc 	; Old ERR_SP item
	pop hl 	; String pointer
	pop af	; Deletion flag
	or a
	call nz, __MEM_FREE	; Frees string content before returning

	ld hl, (TMP)
	ld (ERR_SP), hl	; Restores ERR_SP

	jp __FPSTACK_POP	; Recovers result and return from there

__VAL_EMPTY:	; Jumps here on empty string
	pop hl
	pop af
	or a
	call nz, __MEM_FREE ; Frees "" string
	push af
	jr __RET_ZERO

__VAL_ERROR:	; Jumps here on ERROR
	pop hl
	pop af
	or a
	call nz, __MEM_FREE

	ld hl, (TMP)
	ld (ERR_SP), hl	; Restores ERR_SP
	ld a, ERROR_Ok
	ld (ERR_NR), a
	push af

__RET_ZERO:	; Returns 0 Floating point on error
	pop af
	ld bc, 0
	ld d, b
	ld e, c
	xor a
	ret

	ENDP

